/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#ifndef INCL_PPROXY_H
#define INCL_PPROXY_H

typedef struct ppdb_struct
{
    char *node;
    pool p;

    /* node data */
    int priority;
    xmlnode x;
    struct ppdb_struct *next;

    /* branch data */
    struct ppdb_struct *branch;
    struct ppdb_struct *primary;
    struct ppdb_struct *current;
} _ppdb, *ppdb;

ppdb ppdb_insert(ppdb db, jid id, xmlnode x); /* inserts presence into the proxy */
xmlnode ppdb_primary(ppdb db, jid id); /* fetches the matching primary presence for the id */
xmlnode ppdb_get(ppdb db, jid id); /* called successively to return each presence xmlnode for the id and children, returns NULL at the end */
void ppdb_free(ppdb db); /* frees the db and all entries */

/* internal */
ppdb _ppdb_new(pool p);
ppdb _ppdb_new_node(xmlnode x, char *node);
ppdb _ppdb_get(ppdb db, char *node);
ppdb _ppdb_primary(ppdb list);
ppdb _ppdb_insert(ppdb list, ppdb old, ppdb new);
ppdb _ppdb_free(ppdb db, ppdb old);

#endif
